/*
 * Copyright 2010-2019 JetBrains s.r.o. and Kotlin Programming Language contributors.
 * Use of this source code is governed by the Apache 2.0 license that can be found in the license/LICENSE.txt file.
 */

package org.jetbrains.kotlin.idea.quickfix;

import com.intellij.testFramework.TestDataPath;
import org.jetbrains.kotlin.test.JUnit3RunnerWithInners;
import org.jetbrains.kotlin.test.KotlinTestUtils;
import org.jetbrains.kotlin.test.TargetBackend;
import org.jetbrains.kotlin.test.TestMetadata;
import org.junit.runner.RunWith;

import java.io.File;
import java.util.regex.Pattern;

/** This class is generated by {@link org.jetbrains.kotlin.generators.tests.TestsPackage}. DO NOT MODIFY MANUALLY */
@SuppressWarnings("all")
@TestMetadata("idea/testData/multiModuleQuickFix")
@TestDataPath("$PROJECT_ROOT")
@RunWith(JUnit3RunnerWithInners.class)
public class QuickFixMultiModuleTestGenerated extends AbstractQuickFixMultiModuleTest {
    private void runTest(String testDataFilePath) throws Exception {
        KotlinTestUtils.runTest(this::doTest, TargetBackend.ANY, testDataFilePath);
    }

    public void testAllFilesPresentInMultiModuleQuickFix() throws Exception {
        KotlinTestUtils.assertAllTestsPresentByMetadata(this.getClass(), new File("idea/testData/multiModuleQuickFix"), Pattern.compile("^([^\\.]+)$"), TargetBackend.ANY, true);
    }

    @TestMetadata("idea/testData/multiModuleQuickFix/accessibilityChecker")
    @TestDataPath("$PROJECT_ROOT")
    @RunWith(JUnit3RunnerWithInners.class)
    public static class AccessibilityChecker extends AbstractQuickFixMultiModuleTest {
        private void runTest(String testDataFilePath) throws Exception {
            KotlinTestUtils.runTest(this::doTest, TargetBackend.ANY, testDataFilePath);
        }

        public void testAllFilesPresentInAccessibilityChecker() throws Exception {
            KotlinTestUtils.assertAllTestsPresentByMetadata(this.getClass(), new File("idea/testData/multiModuleQuickFix/accessibilityChecker"), Pattern.compile("^([^\\.]+)$"), TargetBackend.ANY, true);
        }

        @TestMetadata("classPrimaryConstructor")
        public void testClassPrimaryConstructor() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/accessibilityChecker/classPrimaryConstructor/");
        }

        @TestMetadata("classSecondaryConstructor")
        public void testClassSecondaryConstructor() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/accessibilityChecker/classSecondaryConstructor/");
        }

        @TestMetadata("classUpperBounds")
        public void testClassUpperBounds() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/accessibilityChecker/classUpperBounds/");
        }

        @TestMetadata("errorType")
        public void testErrorType() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/accessibilityChecker/errorType/");
        }

        @TestMetadata("memberFunction")
        public void testMemberFunction() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/accessibilityChecker/memberFunction/");
        }

        @TestMetadata("memberFunctionAndNestedClass")
        public void testMemberFunctionAndNestedClass() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/accessibilityChecker/memberFunctionAndNestedClass/");
        }

        @TestMetadata("memberFunctionParentType")
        public void testMemberFunctionParentType() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/accessibilityChecker/memberFunctionParentType/");
        }

        @TestMetadata("memberFunctionParentType2")
        public void testMemberFunctionParentType2() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/accessibilityChecker/memberFunctionParentType2/");
        }

        @TestMetadata("nestedClassWithTypeParam")
        public void testNestedClassWithTypeParam() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/accessibilityChecker/nestedClassWithTypeParam/");
        }

        @TestMetadata("topLevelFunParameter")
        public void testTopLevelFunParameter() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/accessibilityChecker/topLevelFunParameter/");
        }

        @TestMetadata("topLevelFunReturnType")
        public void testTopLevelFunReturnType() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/accessibilityChecker/topLevelFunReturnType/");
        }

        @TestMetadata("topLevelFunTypeParameter")
        public void testTopLevelFunTypeParameter() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/accessibilityChecker/topLevelFunTypeParameter/");
        }

        @TestMetadata("topLevelFunUpperBounds")
        public void testTopLevelFunUpperBounds() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/accessibilityChecker/topLevelFunUpperBounds/");
        }

        @TestMetadata("topLevelFunUpperBounds2")
        public void testTopLevelFunUpperBounds2() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/accessibilityChecker/topLevelFunUpperBounds2/");
        }

        @TestMetadata("topLevelProperty")
        public void testTopLevelProperty() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/accessibilityChecker/topLevelProperty/");
        }

        @TestMetadata("topLevelPropertyTypeParam2")
        public void testTopLevelPropertyTypeParam2() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/accessibilityChecker/topLevelPropertyTypeParam2/");
        }

        @TestMetadata("topLevelPropertyTypeParamBound")
        public void testTopLevelPropertyTypeParamBound() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/accessibilityChecker/topLevelPropertyTypeParamBound/");
        }
    }

    @TestMetadata("idea/testData/multiModuleQuickFix/addMissingActualMembers")
    @TestDataPath("$PROJECT_ROOT")
    @RunWith(JUnit3RunnerWithInners.class)
    public static class AddMissingActualMembers extends AbstractQuickFixMultiModuleTest {
        private void runTest(String testDataFilePath) throws Exception {
            KotlinTestUtils.runTest(this::doTest, TargetBackend.ANY, testDataFilePath);
        }

        public void testAllFilesPresentInAddMissingActualMembers() throws Exception {
            KotlinTestUtils.assertAllTestsPresentByMetadata(this.getClass(), new File("idea/testData/multiModuleQuickFix/addMissingActualMembers"), Pattern.compile("^([^\\.]+)$"), TargetBackend.ANY, true);
        }

        @TestMetadata("classFunction")
        public void testClassFunction() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/addMissingActualMembers/classFunction/");
        }

        @TestMetadata("classFunctionSameSignature")
        public void testClassFunctionSameSignature() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/addMissingActualMembers/classFunctionSameSignature/");
        }

        @TestMetadata("classFunctionWithConstructor")
        public void testClassFunctionWithConstructor() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/addMissingActualMembers/classFunctionWithConstructor/");
        }

        @TestMetadata("classFunctionWithConstructorAndParameters")
        public void testClassFunctionWithConstructorAndParameters() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/addMissingActualMembers/classFunctionWithConstructorAndParameters/");
        }

        @TestMetadata("classFunctionWithIncompatibleConstructor")
        public void testClassFunctionWithIncompatibleConstructor() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/addMissingActualMembers/classFunctionWithIncompatibleConstructor/");
        }

        @TestMetadata("classOverloadedFunction")
        public void testClassOverloadedFunction() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/addMissingActualMembers/classOverloadedFunction/");
        }

        @TestMetadata("classPropertyInConstructor")
        public void testClassPropertyInConstructor() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/addMissingActualMembers/classPropertyInConstructor/");
        }

        @TestMetadata("classSomeProperties")
        public void testClassSomeProperties() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/addMissingActualMembers/classSomeProperties/");
        }

        @TestMetadata("classWithIncompilableFunction")
        public void testClassWithIncompilableFunction() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/addMissingActualMembers/classWithIncompilableFunction/");
        }

        @TestMetadata("companionAbsence")
        public void testCompanionAbsence() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/addMissingActualMembers/companionAbsence/");
        }

        @TestMetadata("membersWithIncorrectType")
        public void testMembersWithIncorrectType() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/addMissingActualMembers/membersWithIncorrectType/");
        }

        @TestMetadata("primaryConstructorAbsence")
        public void testPrimaryConstructorAbsence() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/addMissingActualMembers/primaryConstructorAbsence/");
        }

        @TestMetadata("propertyWithIncorrectType")
        public void testPropertyWithIncorrectType() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/addMissingActualMembers/propertyWithIncorrectType/");
        }

        @TestMetadata("secondaryConstructorAbsence")
        public void testSecondaryConstructorAbsence() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/addMissingActualMembers/secondaryConstructorAbsence/");
        }
    }

    @TestMetadata("idea/testData/multiModuleQuickFix/changeSignature")
    @TestDataPath("$PROJECT_ROOT")
    @RunWith(JUnit3RunnerWithInners.class)
    public static class ChangeSignature extends AbstractQuickFixMultiModuleTest {
        private void runTest(String testDataFilePath) throws Exception {
            KotlinTestUtils.runTest(this::doTest, TargetBackend.ANY, testDataFilePath);
        }

        @TestMetadata("actual")
        public void testActual() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/changeSignature/actual/");
        }

        public void testAllFilesPresentInChangeSignature() throws Exception {
            KotlinTestUtils.assertAllTestsPresentByMetadata(this.getClass(), new File("idea/testData/multiModuleQuickFix/changeSignature"), Pattern.compile("^([^\\.]+)$"), TargetBackend.ANY, true);
        }

        @TestMetadata("expect")
        public void testExpect() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/changeSignature/expect/");
        }

        @TestMetadata("override")
        public void testOverride() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/changeSignature/override/");
        }

        @TestMetadata("override2")
        public void testOverride2() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/changeSignature/override2/");
        }

        @TestMetadata("override3")
        public void testOverride3() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/changeSignature/override3/");
        }

        @TestMetadata("override4")
        public void testOverride4() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/changeSignature/override4/");
        }

        @TestMetadata("override5")
        public void testOverride5() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/changeSignature/override5/");
        }

        @TestMetadata("override6")
        public void testOverride6() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/changeSignature/override6/");
        }
    }

    @TestMetadata("idea/testData/multiModuleQuickFix/createActual")
    @TestDataPath("$PROJECT_ROOT")
    @RunWith(JUnit3RunnerWithInners.class)
    public static class CreateActual extends AbstractQuickFixMultiModuleTest {
        private void runTest(String testDataFilePath) throws Exception {
            KotlinTestUtils.runTest(this::doTest, TargetBackend.ANY, testDataFilePath);
        }

        @TestMetadata("abstract")
        public void testAbstract() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createActual/abstract/");
        }

        @TestMetadata("abstractClassWithJdk")
        public void testAbstractClassWithJdk() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createActual/abstractClassWithJdk/");
        }

        public void testAllFilesPresentInCreateActual() throws Exception {
            KotlinTestUtils.assertAllTestsPresentByMetadata(this.getClass(), new File("idea/testData/multiModuleQuickFix/createActual"), Pattern.compile("^([^\\.]+)$"), TargetBackend.ANY, true);
        }

        @TestMetadata("annotation")
        public void testAnnotation() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createActual/annotation/");
        }

        @TestMetadata("annotationOptionalExpectation")
        public void testAnnotationOptionalExpectation() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createActual/annotationOptionalExpectation/");
        }

        @TestMetadata("annotationOptionalExpectationNoDir")
        public void testAnnotationOptionalExpectationNoDir() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createActual/annotationOptionalExpectationNoDir/");
        }

        @TestMetadata("annotationWithComment")
        public void testAnnotationWithComment() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createActual/annotationWithComment/");
        }

        @TestMetadata("class")
        public void testClass() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createActual/class/");
        }

        @TestMetadata("classWithBase")
        public void testClassWithBase() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createActual/classWithBase/");
        }

        @TestMetadata("classWithJdk")
        public void testClassWithJdk() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createActual/classWithJdk/");
        }

        @TestMetadata("classWithSuperTypeFromOtherPackage")
        public void testClassWithSuperTypeFromOtherPackage() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createActual/classWithSuperTypeFromOtherPackage/");
        }

        @TestMetadata("constructorWithDelegation")
        public void testConstructorWithDelegation() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createActual/constructorWithDelegation/");
        }

        @TestMetadata("constructorWithJdk")
        public void testConstructorWithJdk() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createActual/constructorWithJdk/");
        }

        @TestMetadata("createWithImport")
        public void testCreateWithImport() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createActual/createWithImport/");
        }

        @TestMetadata("defaultParameterInExpected")
        public void testDefaultParameterInExpected() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createActual/defaultParameterInExpected/");
        }

        @TestMetadata("defaultParameterInExpectedClass")
        public void testDefaultParameterInExpectedClass() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createActual/defaultParameterInExpectedClass/");
        }

        @TestMetadata("defaultParameterInExpectedConstructor")
        public void testDefaultParameterInExpectedConstructor() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createActual/defaultParameterInExpectedConstructor/");
        }

        @TestMetadata("enum")
        public void testEnum() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createActual/enum/");
        }

        @TestMetadata("function")
        public void testFunction() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createActual/function/");
        }

        @TestMetadata("functionSameFile")
        public void testFunctionSameFile() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createActual/functionSameFile/");
        }

        @TestMetadata("inlineClass")
        public void testInlineClass() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createActual/inlineClass/");
        }

        @TestMetadata("interface")
        public void testInterface() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createActual/interface/");
        }

        @TestMetadata("nested")
        public void testNested() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createActual/nested/");
        }

        @TestMetadata("object")
        public void testObject() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createActual/object/");
        }

        @TestMetadata("package")
        public void testPackage() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createActual/package/");
        }

        @TestMetadata("packageIncorrect")
        public void testPackageIncorrect() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createActual/packageIncorrect/");
        }

        @TestMetadata("packageIncorrectEmpty")
        public void testPackageIncorrectEmpty() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createActual/packageIncorrectEmpty/");
        }

        @TestMetadata("primaryConstructor")
        public void testPrimaryConstructor() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createActual/primaryConstructor/");
        }

        @TestMetadata("property")
        public void testProperty() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createActual/property/");
        }

        @TestMetadata("sealed")
        public void testSealed() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createActual/sealed/");
        }

        @TestMetadata("sealedSubclass")
        public void testSealedSubclass() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createActual/sealedSubclass/");
        }

        @TestMetadata("withFakeJvm")
        public void testWithFakeJvm() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createActual/withFakeJvm/");
        }

        @TestMetadata("withRootPackage")
        public void testWithRootPackage() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createActual/withRootPackage/");
        }

        @TestMetadata("withTest")
        public void testWithTest() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createActual/withTest/");
        }

        @TestMetadata("withTestDummy")
        public void testWithTestDummy() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createActual/withTestDummy/");
        }
    }

    @TestMetadata("idea/testData/multiModuleQuickFix/createExpect")
    @TestDataPath("$PROJECT_ROOT")
    @RunWith(JUnit3RunnerWithInners.class)
    public static class CreateExpect extends AbstractQuickFixMultiModuleTest {
        private void runTest(String testDataFilePath) throws Exception {
            KotlinTestUtils.runTest(this::doTest, TargetBackend.ANY, testDataFilePath);
        }

        public void testAllFilesPresentInCreateExpect() throws Exception {
            KotlinTestUtils.assertAllTestsPresentByMetadata(this.getClass(), new File("idea/testData/multiModuleQuickFix/createExpect"), Pattern.compile("^([^\\.]+)$"), TargetBackend.ANY, true);
        }

        @TestMetadata("annotation")
        public void testAnnotation() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/annotation/");
        }

        @TestMetadata("annotation2")
        public void testAnnotation2() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/annotation2/");
        }

        @TestMetadata("class")
        public void testClass() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/class/");
        }

        @TestMetadata("classWithSuperClassAndTypeParameter")
        public void testClassWithSuperClassAndTypeParameter() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/classWithSuperClassAndTypeParameter/");
        }

        @TestMetadata("classWithSuperTypeFromOtherPackage")
        public void testClassWithSuperTypeFromOtherPackage() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/classWithSuperTypeFromOtherPackage/");
        }

        @TestMetadata("commented")
        public void testCommented() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/commented/");
        }

        @TestMetadata("companion")
        public void testCompanion() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/companion/");
        }

        @TestMetadata("createWithImport")
        public void testCreateWithImport() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/createWithImport/");
        }

        @TestMetadata("dataClass")
        public void testDataClass() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/dataClass/");
        }

        @TestMetadata("enum")
        public void testEnum() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/enum/");
        }

        @TestMetadata("enumComplex")
        public void testEnumComplex() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/enumComplex/");
        }

        @TestMetadata("enumEmpty")
        public void testEnumEmpty() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/enumEmpty/");
        }

        @TestMetadata("funWithAccessibleAlias")
        public void testFunWithAccessibleAlias() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/funWithAccessibleAlias/");
        }

        @TestMetadata("funWithAccessibleExpansion")
        public void testFunWithAccessibleExpansion() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/funWithAccessibleExpansion/");
        }

        @TestMetadata("funWithAccessibleParameter")
        public void testFunWithAccessibleParameter() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/funWithAccessibleParameter/");
        }

        @TestMetadata("funWithAccessibleTypeFromCommon")
        public void testFunWithAccessibleTypeFromCommon() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/funWithAccessibleTypeFromCommon/");
        }

        @TestMetadata("funWithJdk")
        public void testFunWithJdk() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/funWithJdk/");
        }

        @TestMetadata("funWithPrivateModifier")
        public void testFunWithPrivateModifier() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/funWithPrivateModifier/");
        }

        @TestMetadata("function")
        public void testFunction() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/function/");
        }

        @TestMetadata("function2")
        public void testFunction2() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/function2/");
        }

        @TestMetadata("functionInInterface")
        public void testFunctionInInterface() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/functionInInterface/");
        }

        @TestMetadata("functionWithImplementationInInterface")
        public void testFunctionWithImplementationInInterface() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/functionWithImplementationInInterface/");
        }

        @TestMetadata("functionWithImplementationInInterface2")
        public void testFunctionWithImplementationInInterface2() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/functionWithImplementationInInterface2/");
        }

        @TestMetadata("inlineClass")
        public void testInlineClass() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/inlineClass/");
        }

        @TestMetadata("inlineClass2")
        public void testInlineClass2() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/inlineClass2/");
        }

        @TestMetadata("innerClassWithTypeParam")
        public void testInnerClassWithTypeParam() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/innerClassWithTypeParam/");
        }

        @TestMetadata("innerClassWithTypeParam2")
        public void testInnerClassWithTypeParam2() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/innerClassWithTypeParam2/");
        }

        @TestMetadata("innerEnum")
        public void testInnerEnum() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/innerEnum/");
        }

        @TestMetadata("memberFunctionAndNestedClass")
        public void testMemberFunctionAndNestedClass() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/memberFunctionAndNestedClass/");
        }

        @TestMetadata("nestedClass")
        public void testNestedClass() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/nestedClass/");
        }

        @TestMetadata("noAccessOnMember")
        public void testNoAccessOnMember() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/noAccessOnMember/");
        }

        @TestMetadata("onMember")
        public void testOnMember() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/onMember/");
        }

        @TestMetadata("primaryConstructor")
        public void testPrimaryConstructor() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/primaryConstructor/");
        }

        @TestMetadata("property")
        public void testProperty() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/property/");
        }

        @TestMetadata("property2")
        public void testProperty2() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/property2/");
        }

        @TestMetadata("propertyInConstructor")
        public void testPropertyInConstructor() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/propertyInConstructor/");
        }

        @TestMetadata("propertyWithConstModifier")
        public void testPropertyWithConstModifier() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/propertyWithConstModifier/");
        }

        @TestMetadata("propertyWithLateinitModifier")
        public void testPropertyWithLateinitModifier() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/propertyWithLateinitModifier/");
        }

        @TestMetadata("propertyWithPrivateModifier")
        public void testPropertyWithPrivateModifier() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/propertyWithPrivateModifier/");
        }

        @TestMetadata("sealedClass")
        public void testSealedClass() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/sealedClass/");
        }

        @TestMetadata("stdlibWithJavaAlias")
        public void testStdlibWithJavaAlias() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/stdlibWithJavaAlias/");
        }

        @TestMetadata("superTypeFromStdlib")
        public void testSuperTypeFromStdlib() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/superTypeFromStdlib/");
        }

        @TestMetadata("topLevelFunctionWithAnnotations")
        public void testTopLevelFunctionWithAnnotations() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/topLevelFunctionWithAnnotations/");
        }

        @TestMetadata("topLevelPropertyWithTypeParam")
        public void testTopLevelPropertyWithTypeParam() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/topLevelPropertyWithTypeParam/");
        }

        @TestMetadata("typeAlias")
        public void testTypeAlias() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/typeAlias/");
        }

        @TestMetadata("withAliases")
        public void testWithAliases() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/withAliases/");
        }

        @TestMetadata("withAnnotations")
        public void testWithAnnotations() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/withAnnotations/");
        }

        @TestMetadata("withConstructorWithParametersWithoutValVar")
        public void testWithConstructorWithParametersWithoutValVar() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/withConstructorWithParametersWithoutValVar/");
        }

        @TestMetadata("withInitializer")
        public void testWithInitializer() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/withInitializer/");
        }

        @TestMetadata("withPlatformNested")
        public void testWithPlatformNested() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/withPlatformNested/");
        }

        @TestMetadata("withRootPackage")
        public void testWithRootPackage() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/withRootPackage/");
        }

        @TestMetadata("withSecondaryConstructor")
        public void testWithSecondaryConstructor() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/withSecondaryConstructor/");
        }

        @TestMetadata("withSecondaryConstructor2")
        public void testWithSecondaryConstructor2() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/withSecondaryConstructor2/");
        }

        @TestMetadata("withSupertype")
        public void testWithSupertype() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/withSupertype/");
        }

        @TestMetadata("withVararg")
        public void testWithVararg() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/createExpect/withVararg/");
        }
    }

    @TestMetadata("idea/testData/multiModuleQuickFix/makeOverridenMemberOpen")
    @TestDataPath("$PROJECT_ROOT")
    @RunWith(JUnit3RunnerWithInners.class)
    public static class MakeOverridenMemberOpen extends AbstractQuickFixMultiModuleTest {
        private void runTest(String testDataFilePath) throws Exception {
            KotlinTestUtils.runTest(this::doTest, TargetBackend.ANY, testDataFilePath);
        }

        @TestMetadata("actual")
        public void testActual() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/makeOverridenMemberOpen/actual/");
        }

        public void testAllFilesPresentInMakeOverridenMemberOpen() throws Exception {
            KotlinTestUtils.assertAllTestsPresentByMetadata(this.getClass(), new File("idea/testData/multiModuleQuickFix/makeOverridenMemberOpen"), Pattern.compile("^([^\\.]+)$"), TargetBackend.ANY, true);
        }

        @TestMetadata("expect")
        public void testExpect() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/makeOverridenMemberOpen/expect/");
        }

        @TestMetadata("hasAbstract")
        public void testHasAbstract() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/makeOverridenMemberOpen/hasAbstract/");
        }

        @TestMetadata("hasOpen")
        public void testHasOpen() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/makeOverridenMemberOpen/hasOpen/");
        }
    }

    @TestMetadata("idea/testData/multiModuleQuickFix/other")
    @TestDataPath("$PROJECT_ROOT")
    @RunWith(JUnit3RunnerWithInners.class)
    public static class Other extends AbstractQuickFixMultiModuleTest {
        private void runTest(String testDataFilePath) throws Exception {
            KotlinTestUtils.runTest(this::doTest, TargetBackend.ANY, testDataFilePath);
        }

        @TestMetadata("actualImplementAsConstructorParam")
        public void testActualImplementAsConstructorParam() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/actualImplementAsConstructorParam/");
        }

        @TestMetadata("actualNoImplementAsConstructorParam")
        public void testActualNoImplementAsConstructorParam() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/actualNoImplementAsConstructorParam/");
        }

        @TestMetadata("actualWithoutExpect")
        public void testActualWithoutExpect() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/actualWithoutExpect/");
        }

        @TestMetadata("addActualToClass")
        public void testAddActualToClass() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/addActualToClass/");
        }

        @TestMetadata("addActualToClassMember")
        public void testAddActualToClassMember() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/addActualToClassMember/");
        }

        @TestMetadata("addActualToTopLevelMember")
        public void testAddActualToTopLevelMember() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/addActualToTopLevelMember/");
        }

        @TestMetadata("addFunctionToCommonClassFromJavaUsage")
        public void testAddFunctionToCommonClassFromJavaUsage() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/addFunctionToCommonClassFromJavaUsage/");
        }

        @TestMetadata("addOperatorByActual")
        public void testAddOperatorByActual() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/addOperatorByActual/");
        }

        @TestMetadata("addOperatorByExpect")
        public void testAddOperatorByExpect() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/addOperatorByExpect/");
        }

        public void testAllFilesPresentInOther() throws Exception {
            KotlinTestUtils.assertAllTestsPresentByMetadata(this.getClass(), new File("idea/testData/multiModuleQuickFix/other"), Pattern.compile("^([^\\.]+)$"), TargetBackend.ANY, true);
        }

        @TestMetadata("convertActualEnumToSealedClass")
        public void testConvertActualEnumToSealedClass() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/convertActualEnumToSealedClass/");
        }

        @TestMetadata("convertActualSealedClassToEnum")
        public void testConvertActualSealedClassToEnum() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/convertActualSealedClassToEnum/");
        }

        @TestMetadata("convertExpectEnumToSealedClass")
        public void testConvertExpectEnumToSealedClass() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/convertExpectEnumToSealedClass/");
        }

        @TestMetadata("convertExpectSealedClassToEnum")
        public void testConvertExpectSealedClassToEnum() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/convertExpectSealedClassToEnum/");
        }

        @TestMetadata("convertPropertyGetterToInitializer")
        public void testConvertPropertyGetterToInitializer() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/convertPropertyGetterToInitializer/");
        }

        @TestMetadata("convertPropertyToFunction")
        public void testConvertPropertyToFunction() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/convertPropertyToFunction/");
        }

        @TestMetadata("createClassFromUsageImport")
        public void testCreateClassFromUsageImport() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/createClassFromUsageImport/");
        }

        @TestMetadata("createClassFromUsageRef")
        public void testCreateClassFromUsageRef() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/createClassFromUsageRef/");
        }

        @TestMetadata("createFunInExpectClass")
        public void testCreateFunInExpectClass() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/createFunInExpectClass/");
        }

        @TestMetadata("createTestOnExpect")
        public void testCreateTestOnExpect() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/createTestOnExpect/");
        }

        @TestMetadata("createValInExpectClass")
        public void testCreateValInExpectClass() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/createValInExpectClass/");
        }

        @TestMetadata("createVarInExpectClass")
        public void testCreateVarInExpectClass() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/createVarInExpectClass/");
        }

        @TestMetadata("deprecatedHeader")
        public void testDeprecatedHeader() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/deprecatedHeader/");
        }

        @TestMetadata("deprecatedHeaderImpl")
        public void testDeprecatedHeaderImpl() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/deprecatedHeaderImpl/");
        }

        @TestMetadata("deprecatedImpl")
        public void testDeprecatedImpl() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/deprecatedImpl/");
        }

        @TestMetadata("deprecatedImplHeader")
        public void testDeprecatedImplHeader() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/deprecatedImplHeader/");
        }

        @TestMetadata("functionTypeParameterToReceiverByHeader")
        public void testFunctionTypeParameterToReceiverByHeader() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/functionTypeParameterToReceiverByHeader/");
        }

        @TestMetadata("functionTypeParameterToReceiverByImpl")
        public void testFunctionTypeParameterToReceiverByImpl() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/functionTypeParameterToReceiverByImpl/");
        }

        @TestMetadata("functionTypeReceiverToParameterByHeader")
        public void testFunctionTypeReceiverToParameterByHeader() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/functionTypeReceiverToParameterByHeader/");
        }

        @TestMetadata("functionTypeReceiverToParameterByImpl")
        public void testFunctionTypeReceiverToParameterByImpl() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/functionTypeReceiverToParameterByImpl/");
        }

        @TestMetadata("generateEqualsInExpect")
        public void testGenerateEqualsInExpect() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/generateEqualsInExpect/");
        }

        @TestMetadata("generateHashCodeInExpect")
        public void testGenerateHashCodeInExpect() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/generateHashCodeInExpect/");
        }

        @TestMetadata("implementAbstractExpectMemberInheritedFromInterface")
        public void testImplementAbstractExpectMemberInheritedFromInterface() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/implementAbstractExpectMemberInheritedFromInterface/");
        }

        @TestMetadata("implementMembersInActualClassNoExpectMember")
        public void testImplementMembersInActualClassNoExpectMember() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/implementMembersInActualClassNoExpectMember/");
        }

        @TestMetadata("implementMembersInImplClassNonImplInheritor")
        public void testImplementMembersInImplClassNonImplInheritor() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/implementMembersInImplClassNonImplInheritor/");
        }

        @TestMetadata("importClassInCommon")
        public void testImportClassInCommon() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/importClassInCommon/");
        }

        @TestMetadata("importClassInFromProductionInCommonTests")
        public void testImportClassInFromProductionInCommonTests() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/importClassInFromProductionInCommonTests/");
        }

        @TestMetadata("importCommonClassInJs")
        public void testImportCommonClassInJs() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/importCommonClassInJs/");
        }

        @TestMetadata("importCommonClassInJvm")
        public void testImportCommonClassInJvm() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/importCommonClassInJvm/");
        }

        @TestMetadata("importCommonFunInJvm")
        public void testImportCommonFunInJvm() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/importCommonFunInJvm/");
        }

        @TestMetadata("importExpectClassWithActualInJvm")
        public void testImportExpectClassWithActualInJvm() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/importExpectClassWithActualInJvm/");
        }

        @TestMetadata("importExpectClassWithoutActualInJvm")
        public void testImportExpectClassWithoutActualInJvm() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/importExpectClassWithoutActualInJvm/");
        }

        @TestMetadata("importFunInCommon")
        public void testImportFunInCommon() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/importFunInCommon/");
        }

        @TestMetadata("makeInlineFromExpect")
        public void testMakeInlineFromExpect() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/makeInlineFromExpect/");
        }

        @TestMetadata("makeInternalFromExpect")
        public void testMakeInternalFromExpect() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/makeInternalFromExpect/");
        }

        @TestMetadata("makeOpenFromActual")
        public void testMakeOpenFromActual() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/makeOpenFromActual/");
        }

        @TestMetadata("makeOpenFromExpect")
        public void testMakeOpenFromExpect() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/makeOpenFromExpect/");
        }

        @TestMetadata("mayBeConstantWithActual")
        public void testMayBeConstantWithActual() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/mayBeConstantWithActual/");
        }

        @TestMetadata("memberFunParameterToReceiverByHeader")
        public void testMemberFunParameterToReceiverByHeader() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/memberFunParameterToReceiverByHeader/");
        }

        @TestMetadata("memberFunParameterToReceiverByImpl")
        public void testMemberFunParameterToReceiverByImpl() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/memberFunParameterToReceiverByImpl/");
        }

        @TestMetadata("memberFunReceiverToParameterByHeader")
        public void testMemberFunReceiverToParameterByHeader() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/memberFunReceiverToParameterByHeader/");
        }

        @TestMetadata("memberFunReceiverToParameterByImpl")
        public void testMemberFunReceiverToParameterByImpl() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/memberFunReceiverToParameterByImpl/");
        }

        @TestMetadata("memberFunToExtensionByHeader")
        public void testMemberFunToExtensionByHeader() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/memberFunToExtensionByHeader/");
        }

        @TestMetadata("memberFunToExtensionByImpl")
        public void testMemberFunToExtensionByImpl() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/memberFunToExtensionByImpl/");
        }

        @TestMetadata("memberValToExtensionByHeader")
        public void testMemberValToExtensionByHeader() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/memberValToExtensionByHeader/");
        }

        @TestMetadata("memberValToExtensionByHeaderWithInapplicableImpl")
        public void testMemberValToExtensionByHeaderWithInapplicableImpl() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/memberValToExtensionByHeaderWithInapplicableImpl/");
        }

        @TestMetadata("memberValToExtensionByImpl")
        public void testMemberValToExtensionByImpl() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/memberValToExtensionByImpl/");
        }

        @TestMetadata("orderHeader")
        public void testOrderHeader() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/orderHeader/");
        }

        @TestMetadata("orderImpl")
        public void testOrderImpl() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/orderImpl/");
        }

        @TestMetadata("safeDeleteForbiddenFromActual")
        public void testSafeDeleteForbiddenFromActual() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/safeDeleteForbiddenFromActual/");
        }

        @TestMetadata("safeDeleteFromActual")
        public void testSafeDeleteFromActual() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/safeDeleteFromActual/");
        }

        @TestMetadata("safeDeleteUsedInAnotherPlatform")
        public void testSafeDeleteUsedInAnotherPlatform() throws Exception {
            runTest("idea/testData/multiModuleQuickFix/other/safeDeleteUsedInAnotherPlatform/");
        }
    }
}
